presentation/Store.Web/Models/Cart.cs
using System.Collections.Generic;

namespace Store.Web.Models
{
    public class Cart
    {
        public IDictionary<int, int> Items { get; set; } = new Dictionary<int, int>();

        public decimal Amount { get; set; }
    }
}

presentation/Store.Web/Models/ErrorViewModel.cs
using System;

namespace Store.Web.Models
{
    public class ErrorViewModel
    {
        public string RequestId { get; set; }

        public bool ShowRequestId => !string.IsNullOrEmpty(RequestId);
    }
}

presentation/Store.Web/Controllers/BookController.cs
using Microsoft.AspNetCore.Mvc;

namespace Store.Web.Controllers
{
    public class BookController : Controller
    {
        private readonly IBookRepository bookRepository;

        public BookController(IBookRepository bookRepository)
        {
            this.bookRepository = bookRepository;
        }

        public IActionResult Index(int id)
        {
            Book book = bookRepository.GetById(id);

            return View(book);
        }
    }
}

presentation/Store.Web/Controllers/CartController.cs
using Microsoft.AspNetCore.Mvc;
using Store.Web.Models;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace Store.Web.Controllers
{
    public class CartController : Controller
    {
        private readonly IBookRepository bookRepository;

        public CartController(IBookRepository bookRepository)
        {
            this.bookRepository = bookRepository;
        }

        public IActionResult Add(int id)
        {
            var book = bookRepository.GetById(id);

            if (!HttpContext.Session.TryGetCart(out Cart cart))
                cart = new Cart();

            if (cart.Items.ContainsKey(id))
            {
                cart.Items[id]++;
                cart.Amount += book.Price;
            }
            else
                cart.Items[id] = 1;

            cart.Amount += book.Price;

            HttpContext.Session.Set(cart);

            return RedirectToAction("Index", "Book", new { id });
        }
    }
}

presentation/Store.Web/Controllers/HomeController.cs
using Microsoft.AspNetCore.Mvc;
using Microsoft.Extensions.Logging;
using Store.Web.Models;
using System.Diagnostics;

namespace Store.Web.Controllers
{
    public class HomeController : Controller
    {
        public IActionResult Index()
        {
            return View();
        }

        [ResponseCache(Duration = 0, Location = ResponseCacheLocation.None, NoStore = true)]
        public IActionResult Error()
        {
            return View(new ErrorViewModel { RequestId = Activity.Current?.Id ?? HttpContext.TraceIdentifier });
        }
    }
}

presentation/Store.Web/Controllers/SearchController.cs
using Microsoft.AspNetCore.Mvc;

namespace Store.Web.Controllers
{
    public class SearchController : Controller
    {
        private readonly BookService bookService;

        public SearchController(BookService bookService)
        {
            this.bookService = bookService;
        }

        // /search/index?query=title
        public IActionResult Index(string query)
        {
            Book[] books = bookService.GetAllByQuery(query);

            return View(books);
        }
    }
}

presentation/Store.Web/Views/Book/Index.cshtml
@model Book

@{
    ViewData["Title"] = Model.Title;
}

<h1>@Model.Title</h1>
<p><strong>@Model.Author</strong></p>
<p>@Model.Description</p>
<p>Цена <strong>@Model.Price</strong></p>
<form action="@Url.Action("Add", "Cart")" method="post">
    <input type="hidden" name="id" value="@Model.Id" />
    <button class="btn btn-outline-success" type="submit">В корзину</button>
</form>

presentation/Store.Web/Views/Home/Index.cshtml
@{ 
    ViewData["Title"] = "Интернет магазин на C#";
}

presentation/Store.Web/Views/Search/Index.cshtml
@model Book[]

@{ 
    ViewData["Title"] = "Index";
} 

<h1>Результат поиска</h1>

@if (Model.Length == 0)
{
    <p>Ничего не найдено</p>
}
else
{
    <ul>
        @foreach (var book in Model)
        {
            <il><a href="@Url.Action("Index", "Book", new { id = book.Id })">@book.Title</a></il>
        }
    </ul>
}

presentation/Store.Web/Views/Shared/_Layout.cshtml
<!DOCTYPE html>
<html lang="ru">
<head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>@ViewData["Title"] - инернет-магазин на C#</title>
    <link rel="stylesheet" href="~/lib/bootstrap/dist/css/bootstrap.min.css" />
    <link rel="stylesheet" href="~/css/site.css" />
</head>
<body>
    <header>
        <nav class="navbar navbar-expand-sm navbar-light bg-white">
            <a class="navbar-brand" asp-area="" asp-controller="Home" asp-action="Index">Интернет магазин на C#</a>
            <form class="form-inline my-2 my-lg-0" action="@Url.Action("Index", "Search")" method="get">
                <input class="form-control mr-sm-2" type="search" name="query" placeholder="автор или название" />
                <button class="btn btn-outline-success my-2 my-sm-0" type="submit" >Искать</button>
            </form>
            <span class="navbar-text ml-auto">
                @{ 
                    if (!Context.Session.TryGetCart(out Cart cart))
                        cart = new Cart();

                    if (cart.Items.Count == 0)
                    {
                        @:Коризна пуста
                    }
                    else
                    {
                        @:Товаров @cart.Items.Count на сумму @cart.Amount
                    }
                }
            </span>
        </nav>
    </header>
    <div class="container">
        <main>
            @RenderBody()
        </main>
    </div>

    <script src="~/lib/jquery/dist/jquery.min.js"></script>
    <script src="~/lib/bootstrap/dist/js/bootstrap.bundle.min.js"></script>
    <script src="~/js/site.js" asp-append-version="true"></script>
    @RenderSection("Scripts", required: false)
</body>
</html>